//+------------------------------------------------------------------+
//|                                               EURUSD Scalper.mq4 |
//|                                   Copyright  2009, Lakshmi Inc. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern double SLM=4.6;
extern double TPM=13;
extern int TrailingStop=175;
extern double Lots=0.1;
double ArrGap=0.0005;
extern int MM=0; // 1 Money Management on, 0 MM off
extern double MaximumRisk        = 0.05;
extern double DecreaseFactor     = 3;


//-- RSI-Div-Arrows ==================================================
//---- buffers
double B1, B2, B3, B4, B5, B6, B7, B8, B9, B10;

double emaFactor1, emaFactor2;
double oldRSI1, oldRSI2;

extern int Rsi_Period1=11;
extern int Rsi_Period2=3;
extern int RsiEMA_Period1=2;
extern int RsiEMA_Period2=6;
//---- variables

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
  //RSI-Div-Arrows ==================================================
   //---- initialisations
    emaFactor1 = 2.0 / (RsiEMA_Period1 + 1);
    emaFactor2 = 2.0 / (RsiEMA_Period2 + 1);
//----   
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   int total=OrdersTotal(), cnt, i, limit;
   int TBO=0;
   int TSO=0;
   int Now=Time[300];
   bool ticket;
   double Spread;
   Spread = MarketInfo(Symbol(),MODE_SPREAD) * Point;
//+------------------------------------------------------------------+
//| check open orders                                                |
//+------------------------------------------------------------------+
   for(cnt=0;cnt<total;cnt++)
   {
   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            TBO=TBO+1; // Add 1 to Buy Order Count
           }
         else
           {
            TSO=TSO+1; // Add 1 to Sell Order Count
           }
        }
   }   

//+------------------------------------------------------------------+
//| indicators                                                       |
//+------------------------------------------------------------------+
   double UB=RSI_Div_Up();
   double DB=RSI_Div_Dn();
   double CMA1=iMA(0,0,3,0,MODE_EMA,PRICE_CLOSE,0);
   double CMA2=iMA(0,0,14,0,MODE_EMA,PRICE_CLOSE,0);
   double CMA3=iMA(0,0,25,0,MODE_EMA,PRICE_CLOSE,0);
   double MA1=iMA(0,0,3,0,MODE_EMA,PRICE_CLOSE,1);
   double SIGMA=iMA(0,0,5,0,MODE_EMA,PRICE_CLOSE,1);
   double MA2=iMA(0,0,14,0,MODE_EMA,PRICE_CLOSE,1);
   double MA3=iMA(0,0,25,0,MODE_EMA,PRICE_CLOSE,1);
   double PMA1=iMA(0,0,3,0,MODE_EMA,PRICE_CLOSE,2);
   double PMA2=iMA(0,0,14,0,MODE_EMA,PRICE_CLOSE,2);
   double PMA3=iMA(0,0,25,0,MODE_EMA,PRICE_CLOSE,2);
   double PDI=iADX(0,0,14,PRICE_CLOSE,MODE_PLUSDI,0);
   double MDI=iADX(0,0,14,PRICE_CLOSE,MODE_MINUSDI,0);
   double ATR=iATR(NULL,0,16,0);
   double SL=SLM*ATR;      
   double TP=TPM*ATR;
//   Print( "UP Buffer=",UB,"Down Buffer=",DB);
//   Print("Up Buffer =", UB, "Down Buffer=",DB);
   
   if(MM==1)
     {
     Lots=LotsOptimized();
     }
   else 
     {
     Lots=Lots;
     }
//+------------------------------------------------------------------+
//| check long                                                       |
//+------------------------------------------------------------------+      
   if
      ( TBO==0 && Time[0]>(Now+300) &&  UB>0 && PDI>MDI && MA1<MA3 && (( MA1<MA2 && CMA1>CMA2 ) || ( PMA1<PMA2 && MA1>MA2 ))  )
      {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Ask-SL,Ask+TP,NULL,16384,0,Green);
         Now=OrderOpenTime();
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice(),"Time ",OrderOpenTime());
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
//+------------------------------------------------------------------+
//| check short                                                      |
//+------------------------------------------------------------------+      
    if
       ( TSO==0 && Time[0]>(Now+300) &&  DB>0 && PDI<MDI && MA1>MA3 && (( MA1>MA2 && CMA1<CMA2 ) || ( PMA1>PMA2 && MA1<MA2 ))  )
       {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Bid+SL,Bid-TP,NULL,16384,0,Red);
         Now=OrderOpenTime();
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice(),"Time ",OrderOpenTime());
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
   
//+------------------------------------------------------------------+
//| modify/close orders                                              |
//+------------------------------------------------------------------+         
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
            if(TSO==1)
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }   
           }
         else // go to short position
           {
            // should it be closed?
            if(TBO==1)
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              } 
           }
        }
     }   
         
//----
   return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Function Calls: RSI_EMA1                                         |
//+------------------------------------------------------------------+      
double RSI_EMA1(int pos, int RSI_Period, double emaFactor, double& oldRSI)
{
double curRSI;
   if(pos==Bars-2) 
      curRSI = iRSI(Symbol(),Period(),RSI_Period,PRICE_CLOSE,pos+1);
   else   
      curRSI = iRSI(Symbol(),Period(),RSI_Period,PRICE_CLOSE,pos)*emaFactor + oldRSI*(1-emaFactor);
      
      
   oldRSI = curRSI;   
   return(curRSI);
}

//+------------------------------------------------------------------+
//| Function Calls: RSI_DIV_ARROWS_UP                                |
//| returns 1 if up arrow on last 3 candles                          |
//+------------------------------------------------------------------+      
double RSI_Div_Up()
{
    B1 = RSI_EMA1(1, Rsi_Period1, emaFactor1, oldRSI1); //-- call FUNCTION
    B2 = RSI_EMA1(1, Rsi_Period2, emaFactor2, oldRSI2); //-- call FUNCTION
    B3 = RSI_EMA1(2, Rsi_Period1, emaFactor1, oldRSI1); //-- call FUNCTION
    B4 = RSI_EMA1(2, Rsi_Period2, emaFactor2, oldRSI2); //-- call FUNCTION
    B7 = RSI_EMA1(3, Rsi_Period1, emaFactor1, oldRSI1); //-- call FUNCTION
    B8 = RSI_EMA1(3, Rsi_Period2, emaFactor2, oldRSI2); //-- call FUNCTION
    B9 = RSI_EMA1(4, Rsi_Period1, emaFactor1, oldRSI1); //-- call FUNCTION
    B10 = RSI_EMA1(4, Rsi_Period2, emaFactor2, oldRSI2); //-- call FUNCTION
    
    if((B1>B2 && B3<B4) || (B3>B4 && B7<B8) || (B7>B8 && B9<B10)) 
      {
         B5=0;
         B6=1;      //-up
      }
      else
      {
         B5=0;
         B6=0;
      }
return(B6);
}


//+------------------------------------------------------------------+
//| Function Calls: RSI_DIV_ARROWS_DOW                               |
//| returns 1 if down arrow on last 3 candles                        |
//+------------------------------------------------------------------+
double RSI_Div_Dn()
{
    B1 = RSI_EMA1(1, Rsi_Period1, emaFactor1, oldRSI1); //-- call FUNCTION
    B2 = RSI_EMA1(1, Rsi_Period2, emaFactor2, oldRSI2); //-- call FUNCTION
    B3 = RSI_EMA1(2, Rsi_Period1, emaFactor1, oldRSI1); //-- call FUNCTION
    B4 = RSI_EMA1(2, Rsi_Period2, emaFactor2, oldRSI2); //-- call FUNCTION
    B7 = RSI_EMA1(3, Rsi_Period1, emaFactor1, oldRSI1); //-- call FUNCTION
    B8 = RSI_EMA1(3, Rsi_Period2, emaFactor2, oldRSI2); //-- call FUNCTION
    B9 = RSI_EMA1(4, Rsi_Period1, emaFactor1, oldRSI1); //-- call FUNCTION
    B10 = RSI_EMA1(4, Rsi_Period2, emaFactor2, oldRSI2); //-- call FUNCTION    
    
    if((B1<B2 && B3>B4) || (B3<B4 && B7>B8) || (B7<B8 && B9>B10))
      {
         B5=1;                  //-dn
         B6=0;
      }
      else
      {
         B5=0;
         B6=0;
      }
return(B5);
}

//+------------------------------------------------------------------+
//| Function Calls: Money Management                                 |
//| returns optimum lot size, copyright Hendrick 2006 from phoenix ea|
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                             Phoenix_5_6_03.mq4   |
//|                                       Copyright  2006, Hendrick |
//|                                                                  |
//+------------------------------------------------------------------+  
double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//---- select lot size
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,1);
//---- calcuulate number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     }

   if(lot<0.1) lot=0.1;
   return(lot);
  }

